#include <spi half duplex esclavo.h>

#FUSES NOMCLR

#use spi(SLAVE, CLK=PIN_B1, DI=PIN_B0, DO=PIN_C7, ENABLE=PIN_A5, MODE=0, BITS=8)

#byte SSPBUF = 0xFC9 //Registro de transmision y buffer de recepcion

int8 comando;

int16 pot;
int16 sensor;
int8 boton;

int8 parte_baja;
int8 parte_alta;

void enviar();

#INT_SSP
void recibe()
{
   while (true)
   {
      if (spi_data_is_in())
      {
         comando = spi_read();//RECIBE el comando
         enviar();
         return;
      }
   }
}


void enviar()
{
   switch (comando)
   {
       case 0x01:
            parte_baja = pot & 0xFF;
            parte_alta = (pot >> 8) & 0xFF;

            SSPBUF = parte_baja;
            break;

       case 0x02:
            SSPBUF = parte_alta;
            break;

       case 0x03:
            parte_baja = sensor & 0xFF;
            parte_alta = (sensor >> 8) & 0xFF;

            SSPBUF = parte_baja;
            break;

       case 0x04:

            SSPBUF = parte_alta;
            break;

       case 0x05:
            SSPBUF = boton;
            break;
   }
      return;
}


void main()
{
   setup_adc(ADC_CLOCK_INTERNAL);
   
   enable_interrupts(INT_SSP);
   enable_interrupts(global);
   
   while(TRUE)
   {
       set_adc_channel (0);//Habilita lectura en PIN AN0
       delay_us(10);
       pot = read_adc();// lectura del potenciometro
      
       set_adc_channel (1);//Habilita lectura en PIN AN1
       delay_us(10);
       sensor = read_adc();// lectura del sensor de gas
       
       boton = input(pin_d0);//lectura del boton
       
      //TODO: User Code
   }

}
