#include <spi half duplex maestro.h>

#FUSES NOMCLR

#use spi (MASTER, CLK=PIN_B1, DI=PIN_B0, DO=PIN_C7, BAUD=9600, MODE=0, BITS=8)

#define enviar PIN_C2 //pin ss

#use i2c(Master,Fast, sda=PIN_B2, scl=PIN_B3, force_sw, stream=OLED_stream)

#define SH1106_128_64 //DEFINE EL MODELO DE LA PANTALLA OLED
//#define SSD1306_128_64

#include "OLED_I2C.c" //libreria oled I2C



int16 pot;
int16 sensor;
int8 boton;


int16 recibe_16bits (int8 comando1, int8 comando2)
{
   int16 parte_baja;
   int16 parte_alta;

   output_bit(enviar,0);  //Habilita la recepcion de datos en esclavo
   spi_write(comando1);  //envia el comando
   output_bit(enviar,1); //Deshabilita la recepcion de datos en esclavo

   delay_us(100);

   output_bit(enviar,0);
   parte_baja = spi_read(0);  //recibe parte baja del valor
   output_bit(enviar,1);

   delay_us(100);

   output_bit(enviar,0);
   spi_write(comando2);  //envia el comando
   output_bit(enviar,1);

   delay_us(100);

   output_bit(enviar,0);
   parte_alta = spi_read(0);  //recibe parte alta del valor
   output_bit(enviar,1);

  return (parte_alta << 8) | (parte_baja & 0xFF);
}




int8 recibe_8bits (int8 comando)
{
   int8 recibido;

   output_bit(enviar,0);  //Habilita la recepcion de datos en esclavo
   spi_write(comando);  //envia el comando
   output_bit(enviar,1); //Deshabilita la recepcion de datos en esclavo

   delay_us(100);

   output_bit(enviar,0);
   recibido = spi_read(0);  //recibe el valor
   output_bit(enviar,1);

   return  recibido;
}


void mostrar()
{
   char texto[20];

   sprintf(texto,"POT=%04lu",pot);
   OLED_DrawText(1,1,texto,1);

   sprintf(texto,"SENSOR=%04lu",sensor);
   OLED_DrawText(1,10,texto,1);

   sprintf(texto,"BOTON=%u",boton);
   OLED_DrawText(1,20,texto,1);

   OLED_Display();//Muestra la informacin en pantalla;
   return;
}


void main()
{
   OLED_Begin();
   OLED_ClearDisplay();
   
   while(TRUE)
   {
 
      pot = recibe_16bits(0x01, 0x02);

      delay_us(100);

      sensor = recibe_16bits(0x03, 0x04);

      delay_us(100);

      boton = recibe_8bits(0x05);

      mostrar();
   }

}
